package cn.wisenergy.service.common;

import cn.wisenergy.common.utils.CardNumberUtil;
import cn.wisenergy.common.utils.R;
import cn.wisenergy.common.utils.SecretkeyUtil;
import cn.wisenergy.mapper.CardMapper;
import cn.wisenergy.mapper.RefillCardMapper;
import cn.wisenergy.model.app.CardInfo;
import cn.wisenergy.model.app.RefillCard;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;

/**
 * @author 86187
 */
@Component
@Slf4j
public class RefillCardManager {

    @Autowired
    private RefillCardMapper refillCardMapper;

    @Autowired
    private CardMapper cardMapper;

    @Transactional(rollbackFor = Exception.class)
    public R<Boolean> addCardMannger(RefillCard byId, BigInteger cardNumber) {
        //获取充值卡的卡数，并生成卡片
        ArrayList<CardInfo> cardInfos = new ArrayList<>();
        BigInteger num = new BigInteger("1");
        //子卡添加
        CardInfo cardInfo = new CardInfo();
        cardInfo.setBatchNumber(byId.getBatchNumber());
        cardInfo.setIsDelete(0);
        cardInfo.setMoney("498");
        cardInfo.setStatus(0);
        cardInfo.setLimit(3);
        cardInfo.setSecretKey(SecretkeyUtil.getSecretkey());
        cardInfo.setCardNumber(String.valueOf(cardNumber));
        cardInfos.add(cardInfo);
        for (int i = 0; i < byId.getCardNumber() - 1; i++) {
            CardInfo card = new CardInfo();
            cardNumber = cardNumber.add(num);
            card.setBatchNumber(byId.getBatchNumber());
            card.setIsDelete(0);
            card.setMoney("498");
            card.setStatus(0);
            card.setLimit(3);
            card.setSecretKey(SecretkeyUtil.getSecretkey());
            card.setCardNumber(String.valueOf(cardNumber));
            cardInfos.add(card);
        }
        int add1 = cardMapper.add(cardInfos);

        if (add1 == 0) {
            return R.ok(1, false);
        }
        int isMakeCard = refillCardMapper.setIsMakeCard(byId.getId());

        if (isMakeCard == 0) {
            return R.ok(1, false);
        }
        return R.ok(0, true);

    }
}
